# Template devis pandoc

## Utilisation

### Méta-données nécessaires

Un [bloc de méta-donnée doit être présent au début du fichier](https://pandoc.org/MANUAL.html#extension-pandoc_title_block).

Le plus simple est d'utiliser un `metadata_yaml_block` au début du fichier markdown / rst:

```
---
destinataire: UCLouvain
title:  'Estimation'
devisnum: 20XX-XX
date: 3 juin 2019
lang: fr-BE
---

Mon devis commence ici
```

### Compilation en odt

Un template odt est disponible. Il est nécessaire de forcer le `data-dir` vers le répertoire correspondant, et pointer le template vers le fichier `content.xml`

```bash
pandoc \
   --template content.xml \
   --data-dir . \
   --from markdown \
   --to odt \
   -o /path/to/devis.odt \
     /pato/from/devis.md
```

Le fichier de méta-données peut également être stocké séparément (nécessite une version récente de pandoc):

```bash
pandoc \
   --template content.xml \
   --data-dir . \
   --from markdown \
   --to odt \
   --metadata-file /path/to/devis.metadata.yml \
   -o /path/to/devis.odt \
     /pato/from/devis.md
```

#### A vérifier après la compilation

- vérifier le contenu, et notamment le bon de commande ;
- vérifier les listes à puce ;
- vérifier les indications par défaut (modalités de paiement, etc.) ;


## Développement / contribution

- le fichier content.xml contient le rendu en xml ;
- le fichier references.odt est le fichier de base. Seul le content.xml compilé est remplacé ;

### Explications sur le dev

### Fichier `styles.xml` de references.odt

#### `First_20_paragraph`

Pandoc attribute le style `First_20_paragraph` au premier paragraphe de chaque section.

Ajout d'un style pour le premier paragraphe, dans le fichier `styles.xml` de l'archive `reference.odt`. Ce style est identique au corps de texte.

```xml
    <!-- ajouté pour pandoc -->
    <style:style style:name="First_20_paragraph" style:display-name="First text body" style:family="paragraph" style:parent-style-name="Standard" style:class="text">
      <style:paragraph-properties fo:margin-top="0cm" fo:margin-bottom="0.212cm" loext:contextual-spacing="false" fo:text-align="justify" style:justify-single-word="false" />
      <style:text-properties style:font-size-asian="10.5pt" />
    </style:style>
    <style:style style:name="List" style:family="paragraph" style:parent-style-name="Text_20_body" style:class="list">
      <style:text-properties style:font-size-asian="12pt" style:font-name-complex="Lohit Hindi1" style:font-family-complex="&#39;Lohit Hindi&#39;" />
    </style:style>
    <!-- fin de l'ajout -->
```
